import { QPQConfig, MatchStoryResult, EventMatchStoryActionProcessor, EventTransformEventParamsActionProcessor, EventTransformResponseResultActionProcessor, EventAutoRespondActionProcessor } from 'quidproquo-core';
import { CloudflareDnsDeployEvent } from 'quidproquo-webserver';
import { CloudFormationCustomResourceEvent, Context } from 'aws-lambda';
type EventInput = [CloudFormationCustomResourceEvent, Context];
type MatchResult = MatchStoryResult<any, any>;
declare const _default: (qpqConfig: QPQConfig) => {
    "@quidproquo-core/event/TransformEventParams": EventTransformEventParamsActionProcessor<EventInput, CloudflareDnsDeployEvent>;
    "@quidproquo-core/event/TransformResponseResult": EventTransformResponseResultActionProcessor<void, CloudflareDnsDeployEvent, void>;
    "@quidproquo-core/event/AutoRespond": EventAutoRespondActionProcessor<CloudflareDnsDeployEvent, MatchResult, boolean>;
    "@quidproquo-core/event/MatchStory": EventMatchStoryActionProcessor<CloudflareDnsDeployEvent, MatchResult>;
};
export default _default;
