import { QPQConfig, MatchStoryResult, EventMatchStoryActionProcessor, EventTransformEventParamsActionProcessor, EventTransformResponseResultActionProcessor, EventAutoRespondActionProcessor, DeployEvent } from 'quidproquo-core';
import { EventBridgeEvent, Context } from 'aws-lambda';
interface CloudFormationEventDetail {
    'stack-id': string;
    'status-details': {
        status: string;
        'status-reason': string;
    };
}
type EventInput = [EventBridgeEvent<"CloudFormation Stack Status Change", CloudFormationEventDetail>, Context];
type MatchResult = MatchStoryResult<any, any>;
declare const _default: (qpqConfig: QPQConfig) => {
    "@quidproquo-core/event/TransformEventParams": EventTransformEventParamsActionProcessor<EventInput, DeployEvent>;
    "@quidproquo-core/event/TransformResponseResult": EventTransformResponseResultActionProcessor<void, DeployEvent, void>;
    "@quidproquo-core/event/AutoRespond": EventAutoRespondActionProcessor<DeployEvent, MatchResult, boolean>;
    "@quidproquo-core/event/MatchStory": EventMatchStoryActionProcessor<DeployEvent, MatchResult>;
};
export default _default;
