import { QPQConfig, MatchStoryResult, EventMatchStoryActionProcessor, EventTransformEventParamsActionProcessor, EventTransformResponseResultActionProcessor, EventAutoRespondActionProcessor } from 'quidproquo-core';
import { EmailSendEvent, EmailSendEventResponse } from 'quidproquo-webserver';
import { CustomMessageTriggerEvent, Context } from 'aws-lambda';
type EventInput = [CustomMessageTriggerEvent, Context];
type MatchResult = MatchStoryResult<any, any>;
declare const _default: (qpqConfig: QPQConfig) => {
    "@quidproquo-core/event/TransformEventParams": EventTransformEventParamsActionProcessor<EventInput, EmailSendEvent>;
    "@quidproquo-core/event/TransformResponseResult": EventTransformResponseResultActionProcessor<EmailSendEventResponse, EmailSendEvent, EmailSendEventResponse>;
    "@quidproquo-core/event/AutoRespond": EventAutoRespondActionProcessor<EmailSendEvent, MatchResult, boolean>;
    "@quidproquo-core/event/MatchStory": EventMatchStoryActionProcessor<EmailSendEvent, MatchResult>;
};
export default _default;
