"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const quidproquo_webserver_1 = require("quidproquo-webserver");
// TODO: Don't use Globals like this
console.log(process.env.storageDriveCreateEntry);
const GLOBAL_STORAGE_DRIVE_NAME = process.env.storageDriveName;
const GLOBAL_STORAGE_DRIVE_RUNTIME = JSON.parse(process.env.storageDriveCreateEntry || "{}");
const getProcessTransformEventParams = () => {
    return ({ eventParams: [s3Event, context] }) => __awaiter(void 0, void 0, void 0, function* () {
        const transformedEventParams = {
            driveName: GLOBAL_STORAGE_DRIVE_NAME,
            filePaths: s3Event.Records.map(r => decodeURIComponent(r.s3.object.key)),
            eventType: quidproquo_webserver_1.StorageDriveEventType.Create,
        };
        return (0, quidproquo_core_1.actionResult)(transformedEventParams);
    });
};
const getProcessTransformResponseResult = (qpqConfig) => {
    // We might need to JSON.stringify the body.
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        // always success
        return (0, quidproquo_core_1.actionResult)(void 0);
    });
};
const getProcessAutoRespond = (qpqConfig) => {
    return (payload) => __awaiter(void 0, void 0, void 0, function* () {
        // always allow
        return (0, quidproquo_core_1.actionResult)(false);
    });
};
const getProcessMatchStory = (qpqConfig) => {
    return () => __awaiter(void 0, void 0, void 0, function* () {
        return (0, quidproquo_core_1.actionResult)(GLOBAL_STORAGE_DRIVE_RUNTIME);
    });
};
exports.default = (qpqConfig) => {
    return {
        [quidproquo_core_1.EventActionType.TransformEventParams]: getProcessTransformEventParams(),
        [quidproquo_core_1.EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
        [quidproquo_core_1.EventActionType.AutoRespond]: getProcessAutoRespond(qpqConfig),
        [quidproquo_core_1.EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
    };
};
