"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const quidproquo_core_1 = require("quidproquo-core");
const utils_1 = require("./utils");
const s3Utils_1 = require("../../../logic/s3/s3Utils");
const getProcessFileListDirectory = (qpqConfig) => {
    return ({ drive, folderPath, maxFiles, pageToken }) => __awaiter(void 0, void 0, void 0, function* () {
        const s3BucketName = (0, utils_1.resolveStorageDriveBucketName)(drive, qpqConfig);
        const s3FileList = yield (0, s3Utils_1.listFiles)(s3BucketName, quidproquo_core_1.qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig), folderPath, maxFiles, pageToken);
        // Add the drive onto the list
        const fileInfos = s3FileList.fileInfos.map((s3fi) => (Object.assign(Object.assign({}, s3fi), { drive })));
        return (0, quidproquo_core_1.actionResult)({
            fileInfos,
            pageToken: s3FileList.pageToken,
        });
    });
};
exports.default = (qpqConfig) => ({
    [quidproquo_core_1.FileActionType.ListDirectory]: getProcessFileListDirectory(qpqConfig),
});
