"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApiKeys = void 0;
const client_api_gateway_1 = require("@aws-sdk/client-api-gateway");
const createAwsClient_1 = require("../createAwsClient");
const getApiKeys = (region, ...keyNames) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const apiGatewayClient = (0, createAwsClient_1.createAwsClient)(client_api_gateway_1.APIGatewayClient, { region });
    const input = {
        includeValues: true,
        limit: 500,
    };
    const res = yield apiGatewayClient.send(new client_api_gateway_1.GetApiKeysCommand(input));
    return (((_a = res.items) === null || _a === void 0 ? void 0 : _a.filter((i) => keyNames.indexOf(i.name) >= 0).map((i) => ({ name: i.name, value: i.value, description: i.description }))) || []);
});
exports.getApiKeys = getApiKeys;
