"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.putItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
const qpqDynamoOrm_1 = require("./qpqDynamoOrm");
const createAwsClient_1 = require("../createAwsClient");
// We currently only support objects as root items in dynamo
// Storing a list (array) as the root of your DynamoDB record is indeed possible,
// but there are some caveats. One of the main challenges is that DynamoDB doesn't support
// complex operations on list items. For instance, you can't perform a conditional update or
// delete on a specific item in the list based on its value. However, you can read and write
// entire lists, and you can append items to a list with an update operation.
//
// TODO?: support lists as root items in dynamo ~ Probably not worth it
// a root list probably should be a table!
// Something like this:
// const convertObjectOrListToDynamoMap = (value: KvsObjectDataType | KvsListDataType): AttributeValue => {
//   const attributeValue = buildAttributeValue(value);
//   if ('M' in attributeValue) {
//     return attributeValue.M!;
//   }
//   if ('L' in attributeValue) {
//     return attributeValue.L!;
//   }
//   throw new Error("Value must be an object or a list");
// }
const convertObjectToDynamoItem = (obj) => {
    return (0, qpqDynamoOrm_1.buildAttributeValue)(obj).M;
};
function putItem(tableName, item, attributes, options, region) {
    return __awaiter(this, void 0, void 0, function* () {
        const dynamoDBClient = (0, createAwsClient_1.createAwsClient)(client_dynamodb_1.DynamoDBClient, { region });
        yield dynamoDBClient.send(new client_dynamodb_1.PutItemCommand({
            TableName: tableName,
            Item: convertObjectToDynamoItem(item),
        }));
    });
}
exports.putItem = putItem;
