"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
const qpqDynamoOrm_1 = require("./qpqDynamoOrm");
const createAwsClient_1 = require("../createAwsClient");
function updateItem(tableName, region, update, key, sortKey) {
    return __awaiter(this, void 0, void 0, function* () {
        const dynamoDBClient = (0, createAwsClient_1.createAwsClient)(client_dynamodb_1.DynamoDBClient, { region });
        const params = {
            TableName: tableName,
            Key: {
                id: (0, qpqDynamoOrm_1.buildAttributeValue)(key),
            },
            UpdateExpression: (0, qpqDynamoOrm_1.buildDynamoUpdateExpression)(update),
            ExpressionAttributeValues: (0, qpqDynamoOrm_1.buildUpdateExpressionAttributeValues)(update),
            ExpressionAttributeNames: (0, qpqDynamoOrm_1.buildUpdateExpressionAttributeNames)(update),
        };
        if (sortKey) {
            params.Key['sk'] = (0, qpqDynamoOrm_1.buildAttributeValue)(sortKey);
        }
        console.log(yield dynamoDBClient.send(new client_dynamodb_1.UpdateItemCommand(params)));
    });
}
exports.updateItem = updateItem;
